<?php

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @package Booklibrary
* @copyright 2009 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru);Rob de Cleen(rob@decleen.com)
* Homepage: http://www.joomlawebserver.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
* @version: 1.5.3 Free $
*
**/

class mosBooklibraryWS{

	/**
	 * Catching information from array - in the correct language
	 * @return array that contains all Output from getWSArray() including the
	 * possibility for user to input the information directly
	 */
	function getArray(){
		$help = mosBooklibraryWS::getWSArray();
		$help1 = array();
		array_push($help1, array(0, _BOOKLIBRARY_WS_NO, ""));
		return array_merge($help1, $help);
	}


	/**
	 * Catching WS Informations array
	 * @return array containing all possible WS and their settings
	 */
	function getWSArray(){
		global $mosConfig_absolute_path;
		$retVal = array();
		array_push($retVal, array(1, _BOOKLIBRARY_AMAZON_COM, "COM"));
		array_push($retVal, array(2, _BOOKLIBRARY_AMAZON_UK, "UK"));
		array_push($retVal, array(3, _BOOKLIBRARY_AMAZON_DE, "DE"));
		array_push($retVal, array(4, _BOOKLIBRARY_AMAZON_JP, "JP"));
		array_push($retVal, array(5, _BOOKLIBRARY_AMAZON_FR, "FR"));
		array_push($retVal, array(6, _BOOKLIBRARY_AMAZON_CA, "CA"));
		return $retVal;
	}
	
	/**
	 * fetching the information depending on the information already in the
	 * $book parameter; if parameter is set to insert information on your own
	 * nothing is done, 
	 * @param booklibrary.class.php store the information that is already
	 * known of this book - $informationFrom must be set at least
	 * @return booklibrary.class.php including all information that should be
	 * added by webservices
	 */	
	function fetchInfos($book){
		if(intval($book->informationFrom) != 0 ){
			if($book->informationFrom < 7)
			{
				return mosBooklibraryWS::fetchAmazonInfosForBookRest($book);//Amazon WS
			}
		} else {
			//information is already provided by the user
			return $book;
		}
	}




	/**
	 * fetch the information from a webservice depending on the $informationFrom
	 * variable set in the $book
	 * @param booklibrary.class.php store the information that is already
	 * known of this book - $informationFrom must be set at least
	 * @return booklibrary.class.php including all information that should be
	 * added by webservices
	 * @global string $booklibrary_configuration
	 */

//***********************   add in function 'books'   *************************

	function fetchAmazonInfos($book) {
	    global $booklibrary_configuration;


//******************************   Added by OrdaSoft   **********************************

	    $param_ws = mosBooklibraryWS::getWsParamById($book->informationFrom);
      $Timestamp=date("Y-m-d")."T".date("H:i:s")."Z";
	    //if amazon.com
	    if (($param_ws == "COM") || ($param_ws == "UK") || ($param_ws == "CA")) {
		    try{
			 if (($param_ws == "UK") || ($param_ws == "CA")) {
			    $client = new soapclient(
			 		"https://webservices.amazon.com/AWSECommerceService/".$param_ws."/AWSECommerceService.wsdl");
			 } else if (($param_ws == "COM")) {
				$client = new soapclient(
					"https://webservices.amazon.com/AWSECommerceService/AWSECommerceService.wsdl");
			        }
			$client->xml_encoding = "UTF-8";
			$params = array(
					'Request' => array(
								'SearchIndex' => 'Books',//add for isbn-13
								'IdType'=> 'ISBN',//ISBN - for isbn-13  'ASIN' - for isbn-10
								'ItemId' => $book->isbn, //'0596005431',
								'ResponseGroup' =>'Large'),//Medium
//old valid				'AWSAccessKeyId' => '1Z21K9KD9G8MAN3VWV82'
					'AWSAccessKeyId' => $booklibrary_configuration['ws']['amazon']['devtag'],
          'AssociateTag' => $booklibrary_configuration['ws']['amazon']['tag'],
          'Timestamp' => $Timestamp,
          'Signature' => "ItemLookup".$Timestamp
					);
			$result = $client->ItemLookup($params);
		    }
		    catch (SoapFault $fault) {
			$retVal = "SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})";
			return $retVal;
//		          trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
		    }
	    }

	    //if amazon. UK--yes DE--yes JP--yes(not reviews) FR--yes CA--yes
	    else {
		    try{
			$client = new soapclient(
			"https://webservices.amazon.com/AWSECommerceService/" . $param_ws . "/AWSECommerceService.wsdl");
			$client->xml_encoding = "UTF-8";
			$params = array(
					'Request' => array(
								'IdType'=> 'ASIN',
								'ItemId' => $book->isbn, //'0596005431',
								'ResponseGroup' =>'Large'),//Medium
//old valid				'AWSAccessKeyId' => '1Z21K9KD9G8MAN3VWV82'
					'AWSAccessKeyId' => $booklibrary_configuration['ws']['amazon']['devtag'],
          'AssociateTag' => $booklibrary_configuration['ws']['amazon']['tag'],
          'Timestamp' => $Timestamp,
          'Signature' => "ItemLookup".$Timestamp
					);
			$result = $client->ItemLookup($params);
		    }
		    catch (SoapFault $fault) {
			$retVal = "SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})";
			return $retVal;
//		          trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
		    }
	    }

	    //Errors test -- 1
	    if (array_key_exists('Errors', $result->OperationRequest)) {
	       $retVal = "SOAP Fault: (faultcode: {$result->OperationRequest->Errors->Error->Code}, faultstring: {$result->OperationRequest->Errors->Error->Message})";
	       return $retVal;
	    }

	    //Errors test -- 2
	    if (array_key_exists('Errors', $result->Items->Request)) {
		$retVal = "SOAP Fault: (faultcode: {$result->Items->Request->Errors->Error->Code}, faultstring: {$result->Items->Request->Errors->Error->Message})";
		return $retVal;
	    }

	    //Body -- Output in joomla form
	    //ProductName
	    $book->title = $result->Items->Item->ItemAttributes->Title;

	    //ImageUrlMedium
	    $book->imageURL = $result->Items->Item->MediumImage->URL;

	    //URL
	    $book->URL = $result->Items->Item->DetailPageURL;

	    //Manufacturer
	    if (array_key_exists('Manufacturer', $result->Items->Item->ItemAttributes)) {
	       $book->manufacturer = $result->Items->Item->ItemAttributes->Manufacturer;
	    }

	    //Author
	    $book->authors = "";
	    if ( is_array($result->Items->Item->ItemAttributes->Author) ) {		//Authors array
	       foreach ($result->Items->Item->ItemAttributes->Author as $Author) {
		       if (strlen($book->authors) > 0) {
			  $book->authors = $book->authors . ", " . $Author;
		       }
		       else { $book->authors = $Author; }
	       }
	    }
	    else {
		  $book->authors = $result->Items->Item->ItemAttributes->Author;		//Authors not array
	    }

	    //Rating
	    if (array_key_exists('CustomerReviews', $result->Items->Item)) {
	       $book->rating = ($result->Items->Item->CustomerReviews->AverageRating * 2);
	    }

	    //PublicationDate
	    if (array_key_exists('PublicationDate', $result->Items->Item->ItemAttributes)) {
	       $book->release_Date = $result->Items->Item->ItemAttributes->PublicationDate;
	    }

	    //ReleaseDate
	    if (array_key_exists('ReleaseDate', $result->Items->Item->ItemAttributes)) {
	       $book->release_Date = $result->Items->Item->ItemAttributes->ReleaseDate;
	    }

	    //Edition
	    if ( array_key_exists('Edition', $result->Items->Item->ItemAttributes) ) {
	       $book->edition = 
             $result->Items->Item->ItemAttributes->Edition;
	    }

	    //Price no partner
	    if ( array_key_exists('Offer', $result->Items->Item->Offers) && array_key_exists('FormattedPrice', $result->Items->Item->Offers->Offer->OfferListing->Price)) {
	       $book->price = $result->Items->Item->Offers->Offer->OfferListing->Price->FormattedPrice;
	       $mas = $book->price;
	       $mas = ereg_replace("\xC2\xA3", "GBP ", $mas);  //for funt
	       $mas = ereg_replace("\xEF\xBF\xA5", "JPY", $mas);  //for ena
	       $book->price = $mas;
	    }
	    else {
		  $book->price = "Does not exist anymore!";
	    }

//************************   begin add for Book Description   *********************
	    $book->comment = "";
//************************   end add for Book Description   ************************

	    return $book;
	}


//***********************   add in function 'books'   *************************

	function fetchAmazonInfosForBookRest($book,$amazon_version = '2009-03-01') {
      global $booklibrary_configuration;
//******************************   Added by OrdaSoft   **********************************

      $param_ws = mosBooklibraryWS::getWsParamById($book->informationFrom);

    if ($param_ws == "COM") $endpoint ="http://ecs.amazonaws.com/onca/xml";
    else if ($param_ws == "UK") $endpoint = "http://ecs.amazonaws.co.uk/onca/xml";
    else if ($param_ws == "CA") $endpoint = "http://ecs.amazonaws.ca/onca/xml";
    else if ($param_ws == "DE") $endpoint = "http://ecs.amazonaws.de/onca/xml";
    else if ($param_ws == "JP") $endpoint = "http://ecs.amazonaws.jp/onca/xml";
    else if ($param_ws == "FR") $endpoint = "http://ecs.amazonaws.fr/onca/xml";

    if($booklibrary_configuration['ws']['amazon']['secret_key'] == "")
      $secret_key = "ooTVCJy06UNXeMujmlyso9Wj4VD1flgEPsCx5HYY"; 
    else $secret_key = $booklibrary_configuration['ws']['amazon']['secret_key']; 
    
    $request = "$endpoint?" .
          "Service=AWSECommerceService" . 
          "&Operation=ItemLookup" . 
          "&Condition=All" . 
          "&Version={$amazon_version}" . 
          "&AWSAccessKeyId=" . $booklibrary_configuration['ws']['amazon']['devtag'] .
          "&AssociateTag=" . $booklibrary_configuration['ws']['amazon']['tag'] . 
          "&SearchIndex=Books" . //add for isbn-13
          "&ResponseGroup=Large" .
          "&IdType=ISBN" . //ISBN - for isbn-13  'ASIN' - for isbn-10
          "&ItemId=$book->isbn";

    // Get a nice array of elements to work with
    $uri_elements = parse_url($request);

    // Grab our request elements
    $request = $uri_elements['query'];
 
    // Throw them into an array
    parse_str($request, $parameters);
 
    // Add the new required paramters
    $parameters['Timestamp'] = gmdate("Y-m-d\TH:i:s\Z");
		$parameters['Version'] = $amazon_version;
 
    // The new authentication requirements need the keys to be sorted
    ksort($parameters);
 
    // Create our new request
    foreach ($parameters as $parameter => $value) {
        // We need to be sure we properly encode the value of our parameter
        $parameter = str_replace("%7E", "~", rawurlencode($parameter));
        $value = str_replace("%7E", "~", rawurlencode($value));
        $request_array[] = $parameter . '=' . $value;
    }   
 
    // Put our & symbol at the beginning of each of our request variables and put it in a string
    $new_request = implode('&', $request_array);
 
    // Create our signature string
    $signature_string = "GET\n{$uri_elements['host']}\n{$uri_elements['path']}\n{$new_request}";
 
		if (function_exists("hash_hmac"))
		{
			$signature = urlencode(base64_encode(hash_hmac('sha256', $signature_string, $secret_key, true)));
		}
		elseif(function_exists("mhash"))
		{
			$signature = urlencode(base64_encode(mhash(MHASH_SHA256,$signature_string,$secret_key)));
		}
    // Create our signature using hash_hmac
 

    // new request
    $request =  "http://{$uri_elements['host']}{$uri_elements['path']}?{$new_request}&Signature={$signature}";

    // Load the call and capture the document returned by the Shopping API
		if((int)ini_get('allow_url_fopen')==1)
    $result = simplexml_load_file($request);
		else
		{
			$retVal = "Error: variable 'allow_url_fopen' in php.ini set 'Off'. Fetch information require this variable On";
			return $retVal;
		}
    
    //Errors test -- 1
    if (array_key_exists('Errors', $result->OperationRequest)) {
        $retVal = "faultcode: {$result->OperationRequest->Errors->Error->Code}, faultstring: {$result->OperationRequest->Errors->Error->Message}";
        return $retVal;
    }

    //Errors test -- 2
    if (array_key_exists('Errors', $result->Items->Request)) {
      $retVal = "faultcode: {$result->Items->Request->Errors->Error->Code}, faultstring: {$result->Items->Request->Errors->Error->Message}";
      return $retVal;
    }

      //Body -- Output in joomla form
      //ProductName
      $book->title = (string)$result->Items->Item->ItemAttributes->Title;

      //ImageUrlMedium
      $book->imageURL = (string)$result->Items->Item->MediumImage->URL;

      //URL
      $book->URL = (string)$result->Items->Item->DetailPageURL;

      //Manufacturer
      if (array_key_exists('Manufacturer', $result->Items->Item->ItemAttributes)) {
         $book->manufacturer = (string)$result->Items->Item->ItemAttributes->Manufacturer;
      }


      //Author
      $i = 0;  
      $book->authors = "";
      foreach($result->Items->Item->ItemAttributes->Author as $item){
          if ($i > 0) $book->authors.=', ';
          $book->authors .= $item ;
          $i++;
      }

      //Rating
      if (array_key_exists('CustomerReviews', $result->Items->Item)) {
         $book->rating = (string)($result->Items->Item->CustomerReviews->AverageRating * 2);
      }

      //PublicationDate
      if (array_key_exists('PublicationDate', $result->Items->Item->ItemAttributes)) {
         $book->release_Date = (string)$result->Items->Item->ItemAttributes->PublicationDate;
      }

      //ReleaseDate
      if (array_key_exists('ReleaseDate', $result->Items->Item->ItemAttributes)) {
         $book->release_Date = (string)$result->Items->Item->ItemAttributes->ReleaseDate;
      }

      //Edition
      if ( array_key_exists('Edition', $result->Items->Item->ItemAttributes) ) {
         $book->edition = (string)$result->Items->Item->ItemAttributes->Edition;
      }

      //Price no partner
      if ( array_key_exists('Offer', $result->Items->Item->Offers) && array_key_exists('FormattedPrice', $result->Items->Item->Offers->Offer->OfferListing->Price)) {
         $book->price = (string)$result->Items->Item->Offers->Offer->OfferListing->Price->FormattedPrice;
         $mas = $book->price;
         $mas = ereg_replace("\xC2\xA3", "GBP ", $mas);  //for funt
         $mas = ereg_replace("\xEF\xBF\xA5", "JPY", $mas);  //for ena
         $book->price = $mas;
      }
      else {
      $book->price = "Does not exist anymore!";
      }

      $book->comment = "";

      return $book;
  }




	
	/**
	 * Get the name of the WS by the id
	 * @param int $id the id of the WS-Name that should be returned
	 * @return string the name of the WS or null if it can't be found
	 */	
	function getWsNameById($id){	
		$services = mosBooklibraryWS::getArray();
		for($i=0, $n=count($services); $i < $n; $i++){
			if(intval($services[$i][0]) == intval($id)){
				return $services[$i][1];
			}		
		}	
		return null;		
	}

	/**
	 * Get the parameter of the WS by the id
	 * @param int $id the id of the WS-pram that should be returned
	 * @return string the parameter of the WS or null if it can't be found
	 */		
	function getWsParamById($id){
		$services = mosBooklibraryWS::getArray();
		for($i=0, $n=count($services); $i < $n; $i++){
			if(intval($services[$i][0]) == intval($id)){
				return $services[$i][2];
			}		
		}	
		return null;	
	}
}
?>
